#Raspberry.py in PiIX07
#print(" by D@CC on 2022BFeb27")

# Python code to illustrate the Module
class Raspberry:
    # First we create a constructor for this class
    # and add members to it, here models
    def __init__(self):
        self.models = ['Pi', 'Pico', 'Generic', 'Other']
    #def end
    # A normal print function
    def outModels(self):
        print('These are the available models for Raspberry object type:')
        for model in self.models:
            print('\t%s ' % model)
	    #for end
    #def end
    def PiIX_help(self):
        print("PiIX_help...........")
        print("list of PiIX functions:")
        #print(" by D@CC on 2022BFeb27")
        print("outModels()")
        print("   creates 4 objects of objectType: Raspberry")
        print("     Pi, Pico, Generic, Other")
        print("   and the following functions:")
        print("show2(arg1,arg2,arg,arg4) where")
        print("   arg1 <str>  is a variable name in double quotes")
        print('               prints "help" if arg1=="isP":')
        print("   arg2 any    is the value of arg1 by using eval(arg1)")
        print('               eg 999, 0b101, 0xffff, 3.0E5 ')
        print('               "a123b", [19,24]')
        print("   arg3 val(str)")
        print("   arg4 <int> or ")
        print("        <bool> = 0 to debug showing errors only")
        print("                 1 to debug showing all debug msgs")
        print("   e.g. IX =  Raspberry()")
        print('        abcd="a123b"')
        print('        z="abcd";IX.show2(z,eval(z),1)')
        print("        will print:")
        print('        <class "'"str'"'> abcd = "a123b" value:')
        print('show(arg1,arg2,int3)')
        print("   to show the value of a variable")
        print("   arg1 <str> is the variable name to show in double quotes")
        print("   arg2 <any> is the variable name")
        print("   int3 <int> 1 to debug showing all debug msgs")
        print("              0 to not show anything")
        print("modulesList()")
        print("   shows a list of modules (functions)")
        print('PiIX_help() (this function)')
        print('.........................')
        print("end of PiIX_help()")
    #def end
    def modulesList(self):
        print("list of all modules in PiIX07:")
        #print(" by D@CC on 2022BFeb27")
        print("  modulesList()")
        print("  outModels()")
        print("  PiIX_help()")
        print("  show()")
        print("  show2()")
        print("end of modulesList")
    #end def
    def show(self,str1,arg2,int3):
        #print(" by D@CC on 2022BFeb27")
        # str1 <str> variable name in double quotes
        # arg2 <any> variable name itself
        # int3 <int>  0 no print (not showing) values
        #             1 always show values
        # e.g.  show("abcd",abcd,isP)
        str2 = str(type(arg2))
        #print("#"+str2+"#")
        if int3==1:
            if str2=="<class 'str'>":
                #print("class str")
                print('\t show- %s: "%s" ' % (str1, arg2) )
            else:
                print('\t show- '+str1,":",  arg2)
            #if end
        else:
            continueDoh=1 
        #if end
    def show2(self,str1,str9,int2):
        #print(" by D@CC on 2022BFeb27")
        if str1=="isP": 
            #print("print out the help")
            self.PiIX_help()
            return
        #if end
        # call using
        # z="abcd";show3(z,eval(z),value(z),isP)
        #print("val(z):",str2)
        str4=str(type(str9))
        #print("#"+str4+"#")
        isProcessed=False
        if str4=="<class 'str'>":
            #print("process str")
            str5=""
            isProcessed=True
        #if end
        if str4=="<class 'bool'>":
            #print("process bool")
            continueDoh=1
            print("boolean")
            print(str9)
            if str9:
               str5=0
            else:
               str5=1
            #if end
            #str5=str(str9)
            isProcessed=True
        #if end
        if isProcessed==False:
            str4="<class 'oth'>"
            # not type <str>
            int5=str9
            #int5=str1
            str5=str(str9)
        #if end
        #arg1 of self doesn't count as an argument
        #print('str1:',str1,'int2:',int2)
        #print('I want to see "a123b" printed out') 
        if int2==1:
            print('\t %s %s %s "%s" value: %s ' % (str4, str1, '=', str9, str5) )
        #if end
        return
    #def end
#class end